#include "common.h"

uint8_t fossbuf[128], fossptr = 0;
void fossil_incoming(uint8_t *data) {
     memcpy(&fossbuf[fossptr], data, strlen(data));
     fossptr += strlen(data);
}

void fossil_outgoing(uint8_t cc) {
     sprintf(msg, "%c", cc);
     print(msg);
}

uint8_t fossil_getch() {
        uint8_t cc, i;
        cc = fossbuf[0];
        for (i=1; i<128; i++) {
            fossbuf[i-1] = fossbuf[i];
        } fossbuf[127] = 0;
        if (fossptr>0) fossptr--;
        return(cc);
}

uint8_t milestone = 0, anything = 0;
void fossil_handler() {
     //sprintf(msg, "Int 14h, AX = %04X\r\n", regs.wordregs[regax]);
	 //print(msg);
	 if (regs.wordregs[regdx]!=0) return;
	 switch (regs.byteregs[regah]) {
            case 0x04: //initialize FOSSIL
                 regs.wordregs[regax] = 0x1954;
                 sprintf(msg, "  Initialize port %u\r\n", regs.wordregs[regdx]);
                 print(msg);
                 break;
            case 0x01: //put character
                 regs.byteregs[regah] = 1;
                 sprintf(msg, "%c", regs.byteregs[regal]);
                 print(msg);
                 if (regs.byteregs[regal]==13) {
                    print("\n");
                    /*if (anything>0)
                    switch (milestone++) {
                        case 0:
                             fossil_incoming("OK\r\n"); break;
                        case 1:
                             fossil_incoming("RING\r\n"); break;
                        case 2:
                             fossil_incoming("CONNECT 2400\r\n"); break;
                   }
                   anything = 0;*/
                 } //else anything = 1;
                 break;
            case 0x02: //get character
                 regs.byteregs[regal] = fossil_getch();
                 regs.byteregs[regah] = 0;
                 break;
            case 0x03: //get modem/line status
                 regs.byteregs[regal] = 16;
                 if (fossptr>0) regs.byteregs[regal] |= 32;
                 regs.byteregs[regah] = 1;
                 break;
       }
             
}
